import operator
import sys

"""
An argument parser for the Python server scripts, that allows one or two host
connection arguments.
"""

USAGE_PREF = "\nUSAGE: \n"
N_USAGE = [f"{sys.argv[0]} <host>\n",
           f"{sys.argv[0]} <terminal host> <card host>\n"]

PORT = 59556


class ArgumentException(Exception):
    pass


class Settings:
    def __init__(self, conns):
        super()
        self.conns = conns

def or_strings(x, y):
    return x + " | " + y

def parse(num_hosts):
    if num_hosts not in [1, 2]:
        raise ArgumentException(USAGE_PREF + reduce(or_strings, N_USAGE))
    # First argument is script name.
    hosts = sys.argv[1:]
    if num_hosts != len(hosts):
        raise ArgumentException(USAGE_PREF + N_USAGE[num_hosts - 1])
    return Settings([{'host': h, 'port': PORT} for h in hosts])
